<?php
/**
* @version $Id: tutorials.class.php 100 2007-11-25 10:00:00Z morshad $
* @package Joomla
* @subpackage Tutorials
* @copyright Copyright (C) 2007 NS Network Organization. All right reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Tutorials Component is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
* Tutorials database table class
* @package Joomla
* @subpackage Tutorials
*/
class mosTutorial extends mosDBTable {
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $catid				= null;
	/** @var int */
	var $sectionid			= null;
	/** @var int */
	var $parentid			= null;
	/** @var string */
	var $title				= null;
	/** @var int */
	var $created_by			= null;
	/** @var string */
	var $url				= null;
	/** @var string */
	var $description		= null;
	/** @var string */
	var $imageurl			= null;
	/** @var datetime */
	var $date				= null;
	/** @var int */
	var $views				= null;
	/** @var int */
	var $hits				= null;
	/** @var int */
	var $published			= null;
	/** @var boolean */
	var $checked_out		= null;
	/** @var time */
	var $checked_out_time	= null;
	/** @var int */
	var $ordering			= null;
	/** @var int */
	var $access				= null;
	/** @var string */
	var $params				= null;

	/**
	* @param database A database connector object
	*/
	function mosTutorial( &$db ) {
		$this->mosDBTable( '#__tutorials', 'id', $db );
	}
	/** overloaded check function */
	function check() {
		// filter malicious code
		$ignoreList = array( 'params' );
		$this->filter( $ignoreList );

		// specific filters
		// $iFilter = new InputFilter();

		//if ($iFilter->badAttributeValue( array( 'href', $this->url ))) {
		//	$this->_error = 'Please provide a valid URL';
		//	return false;
		//}

		/** check for valid name */
		if (trim( $this->title ) == '') {
			$this->_error = 'Tutorial links';
			return false;
		}

		if ( !( eregi( 'http://', $this->url ) || ( eregi( 'https://',$this->url ) )  || ( eregi( 'ftp://',$this->url ) ) ) ) {
			$this->url = 'http://'.$this->url;
		}

		/** check for existing name */
		$query = "SELECT id"
		. "\n FROM #__tutorials "
		. "\n WHERE title = " . $this->_db->Quote( $this->title )
		. "\n AND catid = " . (int) $this->catid
		. "\n AND sectionid = " . (int) $this->sectionid
		;
		$this->_db->setQuery( $query );

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = 'There is a tutorial link already with that title, please try again.';
			return false;
		}
		return true;
	}
}

/**
* Section database table class
* @package Joomla
* @subpackage Tutorials
*/
class mosTutorials_sec extends mosDBTable {
	/** @var int Primary key */
	var $id					= null;
	/** @var string The menu title for the Section (a short name)*/
	var $title				= null;
	/** @var string The full name for the Section*/
	var $name				= null;
	/** @var string */
	var $image				= null;
	/** @var int */
	var $image_position		= null;
	/** @var string */
	var $description		= null;
	/** @var boolean */
	var $published			= null;
	/** @var boolean */
	var $checked_out		= null;
	/** @var time */
	var $checked_out_time	= null;
	/** @var int */
	var $ordering			= null;
	/** @var int */
	var $access				= null;
	/** @var string */
	var $params				= null;

	/**
	* @param database A database connector object
	*/
	function mosTutorials_sec( &$db ) {
		$this->mosDBTable( '#__tutorials_sec', 'id', $db );
	}
	// overloaded check function
	function check() {
		// check for valid name
		if (trim( $this->title ) == '') {
			$this->_error = "Your Section must contain a title.";
			return false;
		}
		if (trim( $this->name ) == '') {
			$this->_error = "Your Section must have a name.";
			return false;
		}
		// check for existing name
		$query = "SELECT id"
		. "\n FROM #__tutorials_sec "
		. "\n WHERE name = " . $this->_db->Quote( $this->name )
		;
		$this->_db->setQuery( $query );

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = "There is a section already with that name, please try again.";
			return false;
		}
		return true;
	}
}

/**
* Category database table class
* @package Joomla
* @subpackage Tutorials
*/
class mosTutorials_cat extends mosDBTable {
	/** @var int Primary key */
	var $id					= null;
	/** @var int */
	var $parent_id			= null;
	/** @var string The menu title for the Category (a short name)*/
	var $title				= null;
	/** @var string The full name for the Category*/
	var $name				= null;
	/** @var string */
	var $image				= null;
	/** @var string */
	var $section			= null;
	/** @var int */
	var $image_position		= null;
	/** @var string */
	var $description		= null;
	/** @var boolean */
	var $published			= null;
	/** @var boolean */
	var $checked_out		= null;
	/** @var time */
	var $checked_out_time	= null;
	/** @var int */
	var $ordering			= null;
	/** @var int */
	var $access				= null;
	/** @var string */
	var $params				= null;

	/**
	* @param database A database connector object
	*/
	function mosTutorials_cat( &$db ) {
		$this->mosDBTable( '#__tutorials_cat', 'id', $db );
	}
	// overloaded check function
	function check() {
		// check for valid name
		if (trim( $this->title ) == '') {
			$this->_error = "La categor&iacute;a debe contener un t&iacute;tulo.";
			return false;
		}
		if (trim( $this->name ) == '') {
			$this->_error = "La categor&iacute;a debe contener un nombre.";
			return false;
		}

		// check for existing name
		$query = "SELECT id"
		. "\n FROM #__tutorials_cat "
		. "\n WHERE name = " . $this->_db->Quote( $this->name )
		. "\n AND section = " . $this->_db->Quote( $this->section )
		;
		$this->_db->setQuery( $query );

		$xid = intval( $this->_db->loadResult() );
		if ($xid && $xid != intval( $this->id )) {
			$this->_error = "Ya existe una categor&iacute;a con ese nombre.";
			return false;
		}
		return true;
	}
}

class tutorial_HTML {
	//create date
	function time_po( $secpo ) { 
		$tiempo = $secpo;
		$timepo = abs ( $tiempo ); 
		$daypo = floor ( $timepo/86400 ); 
		$resto_daypo = $timepo % 86400; 
		$hourpo = floor ( $resto_daypo/3600 ); 
		$resto_hourpo = $resto_daypo % 3600; 
		$minutepo = floor ( $resto_hourpo/60 ); 
		$resto_minutepo = $resto_hourpo % 60; 
		$secpo = floor ( $resto_minutepo );
		
		if ( $daypo == 0 ) {
			if ( $hourpo == 0 ) {	
				if ( $minutepo == 0 ) { 
					$diff = 'few seconds';
				} else if ( $minutepo == 1 ) {
					$diff = '1 minuto';
				} else {
					$diff = $minutepo .' minutos';
				}	
			} else {
					if ( $minutepo == 0 ) { 
					
					} else if ( $minutepo == 1 ) {
						$min = ', 1 minuto';
					} else {
						$min = ', '. $minutepo .' minutos';
				}
					if ( $hourpo == 1 ) {
						$diff = $hourpo .' hora'. $min; 
					} else {
						$diff = $hourpo .' horas'. $min;
					}
			}
		} else {
		
			if ( $hourpo == 0 ) {
			} else if ( $hourpo == 1 ) {
				$hou = $hourpo .' hora'; 
			} else {
				$hou = $hourpo .' horas';
			}
			
			if ( $daypo == 1 ) {
				$diff = $daypo .' d&iacute;a '. $hou;
			} else {
				$diff = $daypo .' d&iacute;as '. $hou;
			}
			
		}
		
		//return $diff .' atr&aacute;s'; 
		return $diff;
	}
	
	//domain host
	function filter( $data ) {
		$banlist = array ("'","\"",";",",","www.");
		for($i=0;$i<31;$i++)
			$banlist[] = chr($i);
		return str_replace ( $banlist, '', strtolower ( $data ) );
	}

	function referrer( $URL ) {
		if(trim($URL) != '')
				   $Url_data = parse_url($URL);
		$ValidURL  = is_array($Url_data) &&
					 strlen(trim(@$Url_data['host']))!=0;
		return $ValidURL?tutorial_HTML::filter(trim($Url_data['host'])):"Direct hit";
	}
	
	// get tutorials css styles
	function tutorialsCSS() {
		global $mosConfig_absolute_path, $mosConfig_live_site, $mainframe;
		
		$cur_template = $mainframe->getTemplate();
		$cssTutorials = '/templates/'. $cur_template .'/css/tutorials.css';
		$cssPath 	  = $mosConfig_absolute_path . $cssTutorials;
		
			if (file_exists( $cssPath ) ){
				$header = "<link rel=\"stylesheet\" type=\"text/css\" href=\"$mosConfig_live_site$cssTutorials\" />\n";
			} else {
				$header = "<link rel=\"stylesheet\" type=\"text/css\" href=\"$mosConfig_live_site/components/com_tutorials/templates/css/tutorials.css\" />\n";
			}
		
		 if (!strpos($mainframe->getHead(), $header))
			echo $tutorials_css = $mainframe->addCustomHeadTag($header);
	}
	
	// get tutorials vote js
	function tutorialsVote() {
		global $mosConfig_live_site, $mainframe;
		
		$header = "<script type=\"text/javascript\" src=\"$mosConfig_live_site/components/com_tutorials/templates/js/ajaxFav.js\"></script>\n";
		
		if (!strpos($mainframe->getHead(), $header))
		echo $tutorials_vote = $mainframe->addCustomHeadTag($header);
	}

}
?>
