<?php
/**
* @version $Id: tutorials.html.php 100 2007-11-25 10:00:00Z morshad $
* @package Joomla
* @subpackage Tutorials
* @copyright Copyright (C) 2007 NS Network Organization. All right reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Tutorials Component is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
* @package Joomla
* @subpackage Tutorials
*/
class HTML_tutorials {
	/**
	* Draws a Item List
	* Used by Tutorial Item Category & Content Section
	*/
	function displaylist( &$rows, $sectionid, $catid, $currentpage=NULL, &$params, &$pageNav ) {
		global $Itemid, $mosConfig_live_site, $hide_js;
		if ( $params->get( 'page_title' ) ) {
			?>
			<div class="componentheading<?php echo $params->get( 'pageclass_sfx' ); ?>">
			<?php echo $currentpage->header; ?>
			</div>
			<?php
		}
		
		if ( $params->get( 'description' ) ) {
		?>
			<div class="contentdescription<?php echo $params->get( 'pageclass_sfx' ); ?>">
			<?php
			// show image
			if ( $currentpage->image ) {
				?>
				<img src="<?php echo $currentpage->img; ?>" align="<?php echo $currentpage->align; ?>" hspace="6" alt="Image" />
				<?php
			}
			echo $currentpage->descrip;
			?>
			</div>
          <?php
		  }
		  ?>
          <form action="index.php" method="post" name="adminForm">
            	<div>
                <?php
				// Displays the Table of Tutorial Items
                if ( count( $rows ) ) {
                    HTML_tutorials::showTutorials( $params, $rows, $sectionid, $catid, $pageNav );
                } else {
					echo 'There are no Items to display';
				}
                ?>
           		</div>
                <?php
                // Displays listing of Section & Categories
                if ( $params->get( 'section_cat_list' ) ) {
                    HTML_tutorials::showSecCatMenu( $params );
                }
                ?>
		</form>
		<?php
		// displays back button
		mosHTML::BackButton ( $params, $hide_js );
	}

	/**
	* Display Tutorials of items
	*/
	function showTutorials( &$params, &$rows, $sectionid, $catid, &$pageNav ) {
		global $mosConfig_live_site, $database, $my, $Itemid, $mosConfig_sef;
		
		if ( $params->get( 'headings' ) ) {
		//Need Code
		}		

		$k = 0;
		foreach ($rows as $row) {
		
			$link = sefRelToAbs( 'index.php?option=com_tutorials&amp;task=go&amp;catid='. $row->catid .'&amp;id='. $row->id );
			$author_link = sefRelToAbs( 'index.php?option=com_user&amp;task=profile&amp;id='. $row->authorid );
			
			// get fav user
			$query = "SELECT *"
			. "\n FROM #__tutorials_votes AS u"
			. "\n WHERE u.tutorialid = " . (int) $row->id
			. "\n AND u.type LIKE 'links'"
			. "\n AND u.userid = " . (int) $my->id
			;
			$database->setQuery( $query );
			$voter = $database->loadResult();
			
			//get fav count
			$query = "SELECT count(*)"
			. "\n FROM #__tutorials_votes AS v"
			. "\n WHERE v.tutorialid = " . (int) $row->id
			. "\n AND v.type LIKE 'links'"
			;
			$database->setQuery( $query );
			$row->fav = $database->loadResult();
			
			//get comments count
			$query = "SELECT count(*)"
			. "\n FROM #__tutorials_comments AS c"
			. "\n WHERE c.tutorialid = " . (int) $row->id
			. "\n AND c.published = 1"
			;
			$database->setQuery( $query );
			$row->comments = $database->loadResult();
			
			if( $my->id ) {
				$tutorialsFavlink = "javascript:addFavourite('". $row->id ."')";
			} else {
				$tutorialsFavlink = sefRelToAbs( 'index.php?option=com_login&amp;task=login' );
			}
			
			$seclink = sefRelToAbs( 'index.php?option=com_tutorials&sectionid='. $row->sectionid .'&Itemid='. $Itemid );
			
			$catlink = sefRelToAbs( 'index.php?option=com_tutorials&amp;catid='. $row->catid .'&amp;Itemid='. $Itemid );
			
			$viewlink = sefRelToAbs( 'index.php?option=com_tutorials&amp;task=view&amp;id='. $row->id .'&amp;Itemid='. $Itemid );
			
			if ( $mosConfig_sef == '0' ) {
				$vslink = urlencode( 'index.php?option=com_tutorials&task=view&id='. $row->id .'&Itemid='. $Itemid );//sef without use
			} else {
				$vslink = $viewlink;
			}
			
			$sharelink = 'http://www.addthis.com/bookmark.php?url='. $vslink .'&amp;title='. $row->title;
			$sharestatus = 'scrollbars=yes,menubar=no,width=620,height=520,resizable=yes,toolbar=no,location=no,status=no';
			
			$menuclass = 'category'.$params->get( 'pageclass_sfx' );
			
			// Create Date
			$create_date 	= null;
			$created_data 	= $row->created;
			$created_time 	= date("Y-m-d H:i");
			$time_diff 		= strtotime ( $created_time ) - strtotime ( $created_data );
			$create_date 	= tutorial_HTML::time_po ( $time_diff );
			
			$domain_url = tutorial_HTML::referrer ( $row->url );
			?>
            
        <div class="tutorials-fav">
              <ul id="tutorials-fav-count-<?php echo $row->id; ?>">
                 <li class="tutorials-fav-star">
                   <div id="tutorials-fav-count">
                   <a href="<?php echo $viewlink; ?>"><?php echo $row->fav; ?></a>
                   </div>
                 </li>
                 <li class="tutorials-fav-it">
                   <div id="tutorials-fav-it">
                   <?php if( $voter ) { ?>
                   Votar!
                   <?php } else { ?>
                   <a href="<?php echo $tutorialsFavlink; ?>">Votar!</a>
                   <?php } ?>
                   </div>
                 </li>
              </ul>
        </div>
            
        <div class="tutorials-body"> 
        
			<div class="tutorials-title">
                <a href="<?php echo $link; ?>" target="_blank">
                <?php echo $row->title ?>
                </a>
            </div>
            
            <?php 
			if ( $row->imageurl ) { 
			?>
              <img src="<?php echo $mosConfig_live_site; ?>/components/com_tutorials/images/<?php echo $row->imageurl; ?>" align="right" hspace="6" alt="Image" class="tutorial-image"/>
            <?php
			} else {
			 
			 	if ( $row->catimg ) {
			?>
				<img src="<?php echo $mosConfig_live_site; ?>/images/stories/<?php echo $row->catimg; ?>" align="right" hspace="6" alt="Image" class="tutorial-image"/>
			  <?php 
				}
			}
			  ?>
            
                <div class="tutorials-submitted">
               		<!--<a href="<?php echo $author_link; ?>">
                    <?php //echo mosAdminMenus::ImageUser( $row->authorid.'uis.png', 's.png', $row->author, 'tutorials-uimg' ); ?></a>-->
					<!--<a href="<?php echo $author_link; ?>">-->
					<?php echo $row->author; ?><!--</a>-->
                    enviado hace
                    <?php echo $create_date; ?> &middot;
                    <?php echo $row->views; ?> lecturas
                </div>
                
                    <div class="tutorials-details">
                    <span class="tutorials-source">
					<?php echo $domain_url; ?> 
                    <small>
                    (<?php echo $row->hits; ?> hits)
                    </small> 
                    -</span> 
					<?php
                    //if ( $params->get( 'item_description' ) ) {
                        echo $row->description;
                    //}
                    ?>
                    <a href="<?php echo $viewlink; ?>">
                    Leer m&aacute;s
                    </a>
                    </div>
                    
                	  <div class="tutorials-options">
                        <a href="<?php echo $viewlink; ?>" class="tutorial-hass tutorial-comlink<?php echo $params->get( 'pageclass_sfx' ); ?>">
						<?php echo $row->comments; ?> Comentarios</a>
                        
                        <a href="#" onclick="window.open('<?php echo $sharelink;?>','addthis','<?php echo $sharestatus;?>'); return false;" class="tutorial-hass">
                        Share</a>
                        
                        <?php HTML_tutorials::EmailIcon( $row, $params, $hide_js );?>
                        
                         <span class="tutorial-hass<?php echo $params->get( 'pageclass_sfx' ); ?>">
                         Topic: <a href="<?php echo $seclink; ?>">
								<?php echo $row->section; ?></a>  &raquo; 
								<a href="<?php echo $catlink; ?>">
								<?php echo $row->category; ?></a>
                         </span>
                      </div>          
        </div>
                
			<?php
			$k = 1 - $k;
		}
		
		//if ( $params->get( 'navigation' ) ) {
			// page navigation
			if ( $sectionid ) {
				$currentpage->nav	 = '&amp;sectionid='. $sectionid;
			}
			if ( $catid ) {
				$currentpage->nav	 = '&amp;catid='. $catid;
			}
		
			?>
			<div id="tutorial-pages">
				<?php
				/*$order = '';
				if ( $lists['order_value'] ) {
					$order = '&amp;order='. $lists['order_value'];
				}
				$filter = '';
				if ( $lists['filter'] ) {
					$filter = '&amp;filter='. $lists['filter'];
				}*/
				
				//$link = 'index.php?option=com_tutorials&amp;task=category&amp;sectionid='. $sectionid .'&amp;id='. $catid .'&amp;Itemid='. $Itemid . $order . $filter;
				
				$pageNavlink = 'index.php?option=com_tutorials'. $currentpage->nav .'&amp;Itemid='. $Itemid;
				
				echo $pageNav->writePagesLinks( $pageNavlink );
				?>
			</div>
			<?php
		//}
	}

	/**
	* Display links to sections and categories
	*/
	function showSecCatMenu( &$params ) {
		global $database, $my, $mosConfig_live_site;

		// function that returns a normal link
		function tut_link ($name, $href) {
			return '<a href="' . $href . '">' . $name . "</a>";
		}
		
			// security check to see if link exists in a menu
			$link = 'index.php?option=com_tutorials';
			$query = "SELECT id"
			. "\n FROM #__menu"
			. "\n WHERE link LIKE '%$link%'"
			. "\n AND published = 1"
			;
			$database->setQuery( $query );
			$_Itemid = $database->loadResult();
			$Itemid  = '&amp;Itemid='. $_Itemid;

		// get ids and names of the specified sections
		$query = "SELECT id, title from #__tutorials_sec"
		. "\n WHERE published = 1"
		. "\n AND access <= " . (int) $my->gid
		;
		$database->setQuery( $query );
		$rows = $database->loadObjectList();
		
		if ( $rows ) {
			for( $i=0, $n=count( $rows ); $i<$n; $i++ ) {
				$sids[] = (int) $rows[$i]->id;
			}
		}
		
		// get the section ids and names
		foreach ($rows as $row) {
			$section_title[$row->id] = $row->title;
		}
		
		if ( $rows ) {
		?>
        
        <div class="tutorial-subbut">
        <a href="<?php echo sefRelToAbs("index.php?option=com_tutorials&task=new" . $Itemid); ?>" title="Enviar Tip"><img src="<?php echo $mosConfig_live_site; ?>/images/M_images/new.png" alt="New" border="0" height="14" width="13">&nbsp;Enviar Tip</a>
        </div>
        
		 <div class="tutorial-menu">
		<?php		
		 foreach ($sids as $tutsid) {
		
			echo '<ul>'; // section level
		
			// get section link
			$section_titles = $section_title[$tutsid];
			$href = sefRelToAbs("index.php?option=com_tutorials&sectionid=$tutsid" . $Itemid);
			
			echo '<li>';	
			echo tut_link($section_titles, $href);
			echo '</li>';
			
			// multidimensional array for storing the menu tree
			$menutree = array();
			
			// get content id, title, and category name where the section id
			// corresponds to the specified section from the database
			$database->setQuery( "SELECT cc.id, cc.title, cc.count"
					. "\n FROM #__tutorials_cat AS cc"
					. "\n WHERE cc.section = $tutsid"
					. "\n AND published = 1"
					. "\n AND access <= '". $my->gid ."'" );
			$rows = $database->loadObjectList();
			
			$count = count( $rows );
			// number of Active Items
			for ( $i = 0; $i < $count; $i++ ) {
				$query = "SELECT COUNT( a.id )"
				. "\n FROM #__tutorials AS a"
				. "\n WHERE a.catid = " . (int) $rows[$i]->id
				;
				$database->setQuery( $query );
				$active = $database->loadResult();
				$rows[$i]->active = $active;
			}
			
			// build the menu tree
			foreach ($rows as $row) {
				$catree[$row->id][$row->title][$row->id] = $row->active;
			}
			
			// create the links for categories and items in the current section
				echo '<div>'; // category level
			 if ( $rows ) {			
				while ( list($catid) = each($catree) ) { 
					while ( list($catname) = each($catree[$catid]) ) {
						$href = sefRelToAbs("index.php?option=com_tutorials&catid=$catid" . $Itemid);
						echo tut_link($catname, $href);
						while ( list($id,$row->active) = each($catree[$catid][$catname]) ) {
							echo ' <small>('. $row->active .')</small> ';
						}
					}
				}
			 } else {
				echo 'There are no categories menu to display';
			 }
				echo '</div>'; // category level
				
				echo '</ul>'; // section level
			
			} // foreach ( $sids as $tutsid )
	
		} else {
			echo 'There are no sections and categories menu to display';
		}	
		?>
		</div>
		<?php
	}
	
	
	/**
	* Show a tutorial item
	* @param object An object with the record data
	*/
	function viewTutorial( &$row, &$params ) {
		global $mosConfig_live_site, $database, $my, $Itemid;
	
		$link = sefRelToAbs( 'index.php?option=com_tutorials&task=go&catid='. $row->catid .'&id='. $row->id );
		$author_link = sefRelToAbs( 'index.php?option=com_user&task=profile&id='. $row->authorid );	
		
			// get fav user
			$query = "SELECT *"
			. "\n FROM #__tutorials_votes AS u"
			. "\n WHERE u.tutorialid = " . (int) $row->id
			. "\n AND u.type LIKE 'links'"
			. "\n AND u.userid = " . (int) $my->id
			;
			$database->setQuery( $query );
			$voter = $database->loadResult();
			
			//get fav count
			$query = "SELECT count(*)"
			. "\n FROM #__tutorials_votes AS v"
			. "\n WHERE v.tutorialid = " . (int) $row->id
			. "\n AND v.type LIKE 'links'"
			;
			$database->setQuery( $query );
			$row->fav = $database->loadResult();
			
		if( $my->id ) {
			$tutorialsFavlink = "javascript:addFavourite('". $row->id ."')";
		} else {
			$tutorialsFavlink = sefRelToAbs( 'index.php?option=com_login&amp;task=login' );
		}
		
		$seclink = sefRelToAbs( 'index.php?option=com_tutorials&sectionid='. $row->sectionid .'&Itemid='. $Itemid );
		
		$catlink = sefRelToAbs( 'index.php?option=com_tutorials&catid='. $row->catid .'&Itemid='. $Itemid );
		
		$viewlink = sefRelToAbs( 'index.php?option=com_tutorials&amp;task=view&amp;id='. $row->id .'&amp;Itemid='. $Itemid );
					
		if ( $mosConfig_sef == '0' ) {
				$vslink = urlencode( 'index.php?option=com_tutorials&task=view&id='. $row->id .'&Itemid='. $Itemid );//sef without use
			} else {
				$vslink = $viewlink;
			}
			
		$sharelink = 'http://www.addthis.com/bookmark.php?url='. $vslink .'&amp;title='. $row->title;
		$sharestatus = 'scrollbars=yes,menubar=no,width=620,height=520,resizable=yes,toolbar=no,location=no,status=no';
			
			// Create Date
			$create_date 	= null;
			$created_data 	= $row->date;
			$created_time 	= date("Y-m-d H:i");
			$time_diff 		= strtotime ( $created_time ) - strtotime ( $created_data );
			$create_date 	= tutorial_HTML::time_po ( $time_diff );
			
			$domain_url = tutorial_HTML::referrer ( $row->url );
			$row->views = ($row->views + 1);
	
	?>
    
    	<div class="tutorials-fav">
              <ul id="tutorials-fav-count2-<?php echo $row->id; ?>">
                 <li class="tutorials-fav-star">
                   <div id="tutorials-fav-count2">
                   <?php echo $row->fav; ?>
                   </div>
                 </li>
                 <li class="tutorials-fav-it">
                   <span id="tutorials-fav-it">
                   <?php if( $voter ) { ?>
                   Votar!
                   <?php } else { ?>
                   <a href="<?php echo $tutorialsFavlink; ?>">Votar!</a>
                   <?php } ?>
                   </span>
                 </li>
              </ul>
        </div>
         
		<div class="tutorials-body">
         
			<div class="tutorials-title">
                <a href="<?php echo $link; ?>" target="_blank">
                <?php echo $row->title ?>
                </a>
            </div>
            
            <?php 
			if ( $row->imageurl ) { 
			?>
              <img style="margin: 5px; float: right;" src="<?php echo $mosConfig_live_site; ?>/components/com_tutorials/images/<?php echo $row->imageurl; ?>" alt="Image" class="tutorial-image"/>
            <?php
			} else {
			 
			 	if ( $row->catimg ) {
			?>
				<img style="margin: 5px; float: right;" src="<?php echo $mosConfig_live_site; ?>/images/stories/<?php echo $row->catimg; ?>" alt="Image" class="tutorial-image"/>
			  <?php 
				}
			}
			  ?>
            
                    <div class="tutorials-details">
                    <?php
                    //if ( $params->get( 'item_description' ) ) {
                        echo $row->description;
                    //}
                    ?>
                    </div>
                    
                        <div class="tutorials-more">
                           <dl>
                             <dt>Enviado hace:</dt>
                                <dd>
								<?php echo $create_date; ?>
                                </dd>
                             <dt>Autor:</dt>
                                <dd>
                                <!--<a href="<?php echo $author_link; ?>"><?php //echo mosAdminMenus::ImageUser( $row->authorid.'uis.png', 's.png', $row->author, 'tutorials-cuimg' ); ?></a>--> 
                                <!--<a href="<?php echo $author_link; ?>">--><?php echo $row->author; ?><!--</a>-->
                            	</dd>
                             <dt>Topic:</dt>
                                <dd>
                                <a href="<?php echo $seclink; ?>">
								<?php echo $row->section; ?></a>  &raquo; 
								<a href="<?php echo $catlink; ?>">
								<?php echo $row->category; ?></a>
                                </dd>
                             <dt>IP origen:</dt>
                                <dd>
                                <a href="<?php echo $link; ?>" target="_blank">
								<?php echo $domain_url; ?></a>
                                <small>(<?php echo $row->hits; ?> hits)</small>
                                </dd>
                             <dt>Visto por:</dt>
                                <dd>
                                <?php echo $row->views; ?> visitantes
                                </dd>
                             <dt>Opciones:</dt>
                                <dd>
                                <a href="#" onclick="window.open('<?php echo $sharelink;?>','addthis','<?php echo $sharestatus;?>'); return false;" class="tutorial-share<?php echo $params->get( 'pageclass_sfx' ); ?>">Share</a>
								<?php HTML_tutorials::EmailIcon( $row, $params, $hide_js );?>
                                </dd>
                           </dl>
                        </div>
        </div>

        <?php HTML_tutorials::showComment( $row, $params ); ?>

    <?php
	}
	
/**
* Show a tutorial comments
* @param object An object with the record data
*/
function showComment( &$row, &$params ) {
  global $database, $mainframe, $Itemid;
  global $mosConfig_absolute_path, $mosConfig_live_site, $my;
  
  	// used for spoof hardening
	$validate = josSpoofValue();

    // count number of comments
	$query = "SELECT count(*)"
	. "\n FROM #__tutorials_comments"
	. "\n WHERE tutorialid = " . (int) $row->id
	. "\n AND published = 1"
	;
	$database->setQuery( $query );
	$total = $database->loadResult();

    // Check if valid user
    $is_user   = $my->id;
	
	$viewlink = sefRelToAbs( 'index.php?option=com_tutorials&amp;task=view&amp;id='. $row->id .'&amp;Itemid='. $Itemid );

    if ( $total >= 0 ) {
	 ?>
     <div class="tutorials-com-wrap">
       	<div id="tutorials-com-header">
        <a href="<?php echo $viewlink; ?>#addComment" id="tutorials-chlink">
        A&ntilde;adir un comentario ( <?php echo $total; ?> )</a>
        </div>  
     	<div class="tutorials-com-body">
     <?php
    // comments query
	$query = "SELECT c.*, u.username AS author, u.id AS authorid, u.usertype"
	. "\n FROM #__tutorials_comments AS c"
	. "\n LEFT JOIN #__users AS u ON u.id = c.userid"
	. "\n WHERE c.tutorialid = " . (int) $row->id
	. "\n AND c.published = 1"
	;
	$database->setQuery( $query );
	$coms = $database->loadObjectList();
		
		$k = 0;
		
        for ($i=0, $n=count( $coms ); $i < $n; $i++) {
            $com = &$coms[$i];
			
			$author_link = sefRelToAbs( 'index.php?option=com_user&task=profile&id='. $com->authorid );
			$comment = stripslashes(preg_replace("/(\015\012)|(\015)|(\012)/","&nbsp;<br />", $com->comments));
			// Create Date
			$create_date 	= null;
			$created_data 	= $com->date;
			$created_time 	= date("Y-m-d H:i");
			$time_diff 		= strtotime ( $created_time ) - strtotime ( $created_data );
			$create_date 	= tutorial_HTML::time_po ( $time_diff );
	  ?> 
        <a name="comment<?php echo $com->id; ?>"></a>
        
         <dl class="tutorials-com-main<?php echo ($k+1); ?>">
         
            <dt class="tutorials-cahd">
            <?php //echo mosAdminMenus::ImageUser( $com->authorid.'uis.png', 's.png', $com->author, 'tutorials-cuimg' ); ?> 
            por 
            <!--<a href="<?php echo $author_link; ?>" id="tutorials-ca">-->
			<?php echo $com->author; ?><!--</a>--> 
            <a href="<?php echo $viewlink; ?>#comment<?php echo $com->id; ?>">
			<?php echo $create_date; ?></a>        
            </dt>
            
            <dd><?php echo $comment; ?></dd> 
            
                     
         </dl>        
    <?php
	$k = 1 - $k;
        }
      }
	?>
    	</div>
    
    <div class="tutorials-com-add">
   
     <div id="tutorials-com-form">
     <a name="addComment"></a>
    <?php
      // show comments form depending on config permissions
      if ($is_user) {      
        // replace previously written comment if it exists in case user
        // has simply mistyped or misread captcha code
        //if (isset($_GET['comments'])) $curr_com = $_GET['comments'];
        //else $curr_com = '';
		
		// url of current page that user will be returned to after comments
		if ($query_string = mosGetParam( $_SERVER, 'QUERY_STRING', '' )) {
			$return = 'index.php?' . $query_string;
		} else {
			$return = 'index.php';
		}
		
		$c_author = sefRelToAbs( 'index.php?option=com_user&task=profile&id='. $my->id );
		
      ?>
      <script language="javascript" type="text/javascript">
		function comment_submit() {
			var form = document.commentForm;
			// do field validation
			if (form.comment.value == "") {
				alert( "Oops, por favor introduzca un comentario..." );
			} else {
				form.submit();
			}
		}
		</script>
        <div id="tutorials-caf">
        	<?php //echo mosAdminMenus::ImageUser( $my->id.'uis.png', 's.png', $my->username, 'tutorials-cuimg' ); ?>  
            por 
            <!--<a href="<?php echo $c_author; ?>">-->
			<?php echo $my->username; ?><!--</a>-->
        </div>
        <form action="<?php echo sefRelToAbs("index.php"); ?>" method="post" name="commentForm" id="commentForm">
        <textarea cols="40" rows="5" style="width:100%" class="inputbox" id="comment" name="comment"></textarea>
        <br /><br />
        <input type="button" value="Enviar comentario" class="button" onclick="comment_submit()" />
        <?php if ($my->id) { ?>
          <input type="hidden" name="userid" value="<?php echo $my->id; ?>" />
        <?php } else { ?>
          <INPUT TYPE="hidden" NAME="userid" value="0" />
        <?php } ?>
        <input type="hidden" name="option" value="com_tutorials" />
		<input type="hidden" name="task" value="comments" />
        <input type="hidden" name="tutorialid" value="<?php echo $row->id; ?>" />
        <input type="hidden" name="parentid" value="0" />
        <input type="hidden" name="published" value="1" />
        <input type="hidden" name="return" value="<?php echo htmlspecialchars( sefRelToAbs( $return ) ); ?>" />
        <input type="hidden" name="<?php echo $validate; ?>" value="1" />
        </form>
       <?php
      } else {
	  ?>
      Commenting has either been disabled on this item or you are not logged in. Click <a href="<?php echo sefRelToAbs( 'index.php?option=com_login&amp;task=login' ); ?>">here</a> to login or <a href="<?php echo sefRelToAbs( 'index.php?option=com_registration&amp;task=register' ); ?>">register</a>, its free!<br><br>
<b>Note:</b> Anonymous commenting is disabled in order to keep the quality of responses to a high standard.
	  <?php
	  }
	  ?>
      </div>

      </div>
      </div>
      <?php

}
	
	/**
	* Writes Email icon | NEED MORE CHANGE
	*/
	function EmailIcon( &$row, &$params, $hide_js ) {
		global $mosConfig_live_site, $Itemid, $task;
		
		//if ( $params->get( 'email' ) && !$params->get( 'popup' ) && !$hide_js ) {
		if ( !$params->get( 'popup' ) && !$hide_js ) {
			$status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=400,height=250,directories=no,location=no';
			
			if ($task == 'view') {
				$_Itemid = '&amp;itemid='. $Itemid;
			} else {
				$_Itemid = '';
			}

			$link 	= 'index2.php?option=com_tutorials&amp;task=emailform&amp;id='. $row->id . $_Itemid;
			?>
				<a href="#" onclick="window.open('<?php echo $link; ?>','win2','<?php echo $status; ?>'); return false;" class="tutorial-hass<?php echo $params->get( 'pageclass_sfx' ); ?>">
                Email</a>
			<?php
		}
	}
	
	/**
	* Writes Email form for filling in the send destination | NEED MORE CHANGE
	*/
	function emailForm( $uid, $title, $template='', $itemid ) {
		global $mainframe;

		// used for spoof hardening
		$validate = josSpoofValue();

		$mainframe->setPageTitle( $title );
		$mainframe->addCustomHeadTag( '<link rel="stylesheet" href="templates/'. $template .'/css/template.css" type="text/css" />' );
		?>
		<script language="javascript" type="text/javascript">
		function submitbutton() {
			var form = document.frontendForm;
			// do field validation
			if (form.email.value == "" || form.youremail.value == "") {
				alert( '<?php echo addslashes( _EMAIL_ERR_NOINFO ); ?>' );
				return false;
			}
			return true;
		}
		</script>

		<form action="index2.php?option=com_tutorials&amp;task=emailsend" name="frontendForm" method="post" onSubmit="return submitbutton();">
		<table cellspacing="0" cellpadding="0" border="0">
		<tr>
			<td colspan="2">
			<?php echo _EMAIL_FRIEND; ?>
			</td>
		</tr>
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td width="130">
			<?php echo _EMAIL_FRIEND_ADDR; ?>
			</td>
			<td>
			<input type="text" name="email" class="inputbox" size="25" />
			</td>
		</tr>
		<tr>
			<td height="27">
			<?php echo _EMAIL_YOUR_NAME; ?>
			</td>
			<td>
			<input type="text" name="yourname" class="inputbox" size="25" />
			</td>
		</tr>
		<tr>
			<td>
			<?php echo _EMAIL_YOUR_MAIL; ?>
			</td>
			<td>
			<input type="text" name="youremail" class="inputbox" size="25" />
			</td>
		</tr>
		<tr>
			<td>
			<?php echo _SUBJECT_PROMPT; ?>
			</td>
			<td>
			<input type="text" name="subject" class="inputbox" maxlength="100" size="40" />
			</td>
		</tr>
		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>
		<tr>
			<td colspan="2">
			<input type="submit" name="submit" class="button" value="<?php echo _BUTTON_SUBMIT_MAIL; ?>" />
			&nbsp;&nbsp;
			<input type="button" name="cancel" value="<?php echo _BUTTON_CANCEL; ?>" class="button" onclick="window.close();" />
			</td>
		</tr>
		</table>

		<input type="hidden" name="id" value="<?php echo $uid; ?>" />
		<input type="hidden" name="itemid" value="<?php echo $itemid; ?>" />
		<input type="hidden" name="<?php echo $validate; ?>" value="1" />
		</form>
		<?php
	}

	/**
	* Writes Email sent popup
	* @param string Who it was sent to
	* @param string The current template
	*/
	function emailSent( $to, $template='' ) {
		global $mosConfig_sitename, $mainframe;

		$mainframe->setPageTitle( $mosConfig_sitename );
		$mainframe->addCustomHeadTag( '<link rel="stylesheet" href="templates/'. $template .'/css/template.css" type="text/css" />' );
		?>
		<span class="contentheading"><?php echo _EMAIL_SENT." $to";?></span> <br />
		<br />
		<br />
		<a href='javascript:window.close();'>
		<span class="small"><?php echo _PROMPT_CLOSE;?></span>
		</a>
		<?php
	}

	/**
	* Writes the edit form for new and existing tutorial item
	*
	* A new record is defined when <var>$row</var> is passed with the <var>id</var>
	* property set to 0.
	* @param mosTutorial The category object
	* @param string The html for the groups select list
	*/
	function editTutorial( &$row, $option, &$lists, &$sectioncategories ) {
		global $mainframe, $my, $mosConfig_live_site;
		
		mosMakeHtmlSafe( $row, ENT_QUOTES, 'description' );
		
		// used for spoof hardening
		$validate = josSpoofValue();
		
		$author_link = sefRelToAbs( 'index.php?option=com_user&task=profile&id='. $my->id );	
		
		?>
       
        <script language="javascript" type="text/javascript">
		var sectioncategories = new Array;
		<?php
		$i = 0;
		foreach ($sectioncategories as $k=>$items) {
			foreach ($items as $v) {
				echo "sectioncategories[".$i++."] = new Array( '$k','".addslashes( $v->id )."','".addslashes( $v->title )."' );\t";
			}
		}
		?>
		
		function submitbutton_tutorial() {
			var form = document.adminForm;
			
			// do field validation
			if (form.title.value == ""){
				alert( "Debe introducir un t&iacute;tulo para el tip." );
			} else if (form.sectionid.value == "-1"){
				alert( "Debe seleccionar una secci&iacute;n." );
			} else if (form.catid.value == "-1"){
				alert( "Debe seleccionar una categor&iacute;a." );
			} else if (form.url.value == ""){
				alert( "Debe proporcionar una url." );
			} else if (form.description.value == ""){
				alert( "Debe introducir un texto para el tip." );
			} else {
				form.submit();
			}
		}
		
		<!--
		function getObject(obj) {
		  var theObj;
		  if(document.all) {
			if(typeof obj=="string") {
			  return document.all(obj);
			} else {
			  return obj.style;
			}
		  }
		  if(document.getElementById) {
			if(typeof obj=="string") {
			  return document.getElementById(obj);
			} else {
			  return obj.style;
			}
		  }
		  return null;
		}
		
		
		function Contar(entrada,salida,texto,caracteres) {
		  var entradaObj=getObject(entrada);
		  var salidaObj=getObject(salida);
		  var longitud=caracteres - entradaObj.value.length;
		  if(longitud <= 0) {
			longitud=0;
			texto='<span class="disable"> '+texto+' </span>';
			entradaObj.value=entradaObj.value.substr(0,caracteres);
		  }
		  salidaObj.innerHTML = texto.replace("{CHAR}",longitud);
		}
		
		//-->
		
		<!--
		function ReloadtextDiv(textName,divName) {
			var Newtext = document.getElementById(textName).value;
			var DivElement = document.getElementById(divName);
			DivElement.innerHTML = Newtext;
		}
		//-->
		
		<!--
		function urldisplay(urlLink,divName) {
			field = document.getElementById(urlLink).value;
			a = document.getElementById(divName);
			path = field;
			a.href = path;
		}
		//-->
		
		</script>
		
		<form action="<?php echo sefRelToAbs("index.php"); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data">
        
        <div class="componentheading">
			Enviar un nuevo tip
		</div>

		<table border="0" cellpadding="0" cellspacing="10" width="100%" class="contentpane">
		<tr>
			<td>
			<label for="tutitle">
            <span class="tut-edit-title">
            T&iacute;tulo
            </span> 
            <span class="smallgrey">
            (Por favor, introduzca un t&iacute;tulo descriptivo para el tip que va a enviar.)
            </span>
            </label>
            <span class="tutitleCount">
            <span id="titleCounter">250</span> 
            caracteres restantes
            </span><br />
			<input class="inputbox" type="text" name="title" id="tutitle" value="<?php echo $row->title;?>" size="60" onKeyUp="Contar('tutitle','titleCounter','{CHAR}',250); ReloadtextDiv('tutitle','titleDisplay');" />
			</td>
		</tr>
		<tr>
			<td>
			<label for="tuturl">
            <span class="tut-edit-title">
            URL completa del sitio Web asociado al tip
            </span>  
            <span class="smallgrey">
            (Incluyendo http://)
            </span>
            </label><br />
			<input class="inputbox" type="text" name="url" id="tuturl" value="<?php echo $row->url; ?>" size="250" onkeyup="urldisplay('tuturl','titleDisplay');" />
			</td>
		</tr>
		<tr>
			<td>
			<label for="tutdescription">
            <span class="tut-edit-title">
            Descripci&oacute;n
            </span> 
            <span class="smallgrey">
            (Escriba su propia descripci&oacute;n del tip.)
            </span>
            </label>
            <span class="tutdesCount">
            <span id="desCounter">1000</span> 
            caracteres restantes
            </span><br />
			<textarea  name="description" id="tutdescription" class="inputbox" cols="50" rows="5" onKeyUp="Contar('tutdescription','desCounter','{CHAR}',1000); ReloadtextDiv('tutdescription','descrDisplay');"><?php echo $row->description; ?></textarea>
			</td>
		</tr>
        <tr>
			<td>
            <span class="tut-edit-title">
            Escoja el &aacute;rea m&aacute;s apropiada
            </span> 
            <span class="smallgrey">
            (Por favor, seleccione primero una categor&iacute;a)
            </span><br />
			<?php echo $lists['sectionid']; ?>&nbsp;&nbsp;&nbsp;<?php echo $lists['catid']; ?>
			</td>
        </tr>
		<tr>
			<td>
			<label for="tutimage"><span class="tut-edit-title">Cargar imagen</span> <span class="smallgrey">(Haga Clic en Browse para subir una imagen del disco duro)</span></label><br />
            <?php echo $lists['image']; ?>
			</td>
		</tr>
		</table>
        <br /><br />
        <fieldset class="tutorial-preview">
          <legend>Previsualizar el tip <span>(Encontr&oacute; alg&uacute;n problema? Vea los cambios debajo.)</span></legend>
        
            <div class="tutorials-fav">
              <ul id="tutorials-fav-count-">
                 <li class="tutorials-fav-star">
                   <div id="tutorials-fav-count">
                   <a href="#">1</a>
                   </div>
                 </li>
                 <li class="tutorials-fav-it">
                   <div id="tutorials-fav-it">
                    <a href="#">Votar!</a>
                   </div>
                 </li>
              </ul>
        	</div>   
            
        <div class="tutorials-body">
			<div class="tutorials-title">
             <a href="#" id="titleDisplay" target="_blank">
             </a>
            </div>
            
			<img style="margin:5px;float:right;" src="<?php echo $mosConfig_live_site; ?>/components/com_tutorials/images/images.png" alt="Image" class="tutorial-image" />
               
                <div class="tutorials-submitted">
               		<!--<a href="<?php echo $author_link; ?>"><?php //echo mosAdminMenus::ImageUser( $my->id.'uis.png', 's.png', $my->username, 'tutorials-cuimg' ); ?></a>-->
					<!--<a href="<?php echo $author_link; ?>">-->
					<?php echo $my->username; ?><!--</a>--> Enviado hace 5 minutos &middot; 3 lecturas
                </div>

                
                    <div class="tutorials-details">
                    <span class="tutorials-source">ejemplo.com 
                    <small>(1 hits)</small> -</span> 
					<span id="descrDisplay"></span>                    
                    <a href="#">Leer m&aacute;s</a>
                    </div>
                    
                	  <div class="tutorials-options">
                        <a href="#" class="tutorial-hass tutorial-comlink">0 Comentarios</a>
                        <a href="#" class="tutorial-hass">Share</a>
                        <a href="#" class="tutorial-hass">Email</a>           
                        <span class="tutorial-hass">Topic: 
                        <a href="#">Section</a>  &raquo; 
						<a href="#">Categor&iacute;a</a>
                        </span>
                      </div>
        </div>
		<br /><br />
            
            <div class="tut-fieldset-footer">
            <input type="button" value="Enviar tip" class="button" onclick="submitbutton_tutorial()" />
            </div>
        </fieldset>

		<input type="hidden" name="id" value="<?php echo $row->id; ?>" />
		<input type="hidden" name="option" value="<?php echo $option;?>" />
		<input type="hidden" name="task" value="saveTutorial" />
		<input type="hidden" name="created_by" value="<?php echo $row->created;?>" />
        <input type="hidden" name="published" value="<?php echo $row->published; ?>" />
        <input type="hidden" name="ordering" value="<?php echo $row->ordering; ?>" />
		<input type="hidden" name="<?php echo $validate; ?>" value="1" />
		</form>
		<?php
	}
}
?>
