<?php
/**
* @version $Id: tutorials.php 100 2007-11-25 10:00:00Z morshad $
* @package Joomla
* @subpackage Tutorials
* @copyright Copyright (C) 2007 NS Network Organization. All right reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Tutorials Component is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/** load the html drawing class */
require_once( $mainframe->getPath( 'front_html' ) );
require_once( $mainframe->getPath( 'class' ) );

// get the language
	if ( file_exists($mosConfig_absolute_path.'/components/com_tutorials/language/'. $tutorials_lan .'.php') ) {
			require($mosConfig_absolute_path.'/components/com_tutorials/language/'. $tutorials_lan .'.php');
		} else {
			require($mosConfig_absolute_path.'/components/com_tutorials/language/english.php');
		}

$id 		= intval( mosGetParam( $_REQUEST, 'id', 0 ) );
$catid 		= intval( mosGetParam( $_REQUEST, 'catid', 0 ) );
$sectionid 	= intval( mosGetParam( $_REQUEST, 'sectionid', 0 ) );
$limit 		= intval( mosGetParam( $_REQUEST, 'limit', 0 ) );
$limitstart = intval( mosGetParam( $_REQUEST, 'limitstart', 0 ) );

// Editor usertype check
$access = new stdClass();
$access->canEdit = $acl->acl_check( 'action', 'edit', 'users', $my->usertype, 'tutorials', 'all' );
$access->canEditOwn = $acl->acl_check( 'action', 'edit', 'users', $my->usertype, 'tutorials', 'own' );
$access->canPublish = $acl->acl_check( 'action', 'publish', 'users', $my->usertype, 'tutorials', 'all' );

//get tutorials css
tutorial_HTML::tutorialsCSS();

switch ($task) {
	case 'new':
		editTutorial( $option, 0 );
		break;
		
	case 'edit':
		editTutorial( $option, $id );
		break;

	case 'saveTutorial':
		saveTutorial( $option );
		break;

	case 'cancel':
		cancelTutorial( $option );
		break;

	case 'go':
		getLink( $id );
		break;
		
	case 'view':
		viewTutorial( $id );
		tutorial_HTML::tutorialsVote();
		break;
		
	case 'emailform':
		emailForm( $id, $gid );
		break;

	case 'emailsend':
		emailSend( $id, $gid );
		break;
		
	case 'favourite':
		recordFav ();
		break;
		
	case 'comments':
		saveComment ();
		break;

	default:
		listTutorials( $sectionid, $catid, $limit, $limitstart );
		tutorial_HTML::tutorialsVote();
		break;
}

function listTutorials( $sectionid, $catid, $limit, $limitstart ) {
	global $mainframe, $database, $my, $mosConfig_live_site, $mosConfig_list_limit, $Itemid;

	// Parameters
	$menu = $mainframe->get( 'menu' );
	$params = new mosParameters( $menu->params );
	$params->def( 'page_title', 1 );
	$params->def( 'header', $menu->name );
	$params->def( 'description', 1 );
	$params->def( 'description_text', '' );
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'section_cat_list', 1 );
	$params->def( 'image', '-1' );
	$params->def( 'image_align', 'right' );
	$params->def( 'display_num', '10' );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );
	
	// get section items
	$currentsec = null;
	if ( $sectionid ) {
		$where[] = "sectionid = " . (int) $sectionid;
		// cate info
		$query = "SELECT *"
		. "\n FROM #__tutorials_sec"
		. "\n WHERE id = " . (int) $sectionid
		. "\n AND published = 1"
		. "\n AND access <= " . (int) $my->gid
		;
		$database->setQuery( $query );
		$database->loadObject( $currentsec );
		
		/*
		Check if the section is published or if access level allows access
		*/
		if (!$currentsec->published) {
			mosNotAuth();
			return;
		}
		
		// page title
		$mainframe->SetPageTitle( $currentsec->name );
		// page header
		$currentpage->header = $currentsec->name;
		// page description
		$currentpage->descrip = $currentsec->description;
		// page image
		$currentpage->image = $currentsec->image;
		$currentpage->img 	= $mosConfig_live_site .'/images/stories/'. $currentsec->image;
		$currentpage->align = $currentsec->image_position;
		
	}
	
	// get category items
	$currentcat = null;
	if ( $catid ) {
		$where[] = "catid = " . (int) $catid;
		// cate info
		$query = "SELECT *"
		. "\n FROM #__tutorials_cat"
		. "\n WHERE id = " . (int) $catid
		. "\n AND published = 1"
		. "\n AND access <= " . (int) $my->gid
		;
		$database->setQuery( $query );
		$database->loadObject( $currentcat );
		
		/*
		Check if the category is published or if access level allows access
		*/
		if (!$currentcat->published) {
			mosNotAuth();
			return;
		}
		
		// page title
		$mainframe->SetPageTitle( $currentcat->name );
		// page header
		$currentpage->header = $currentcat->name;
		// page description
		$currentpage->descrip = $currentcat->description;
		// page image
		$currentpage->image = $currentcat->image;
		$currentpage->img 	= $mosConfig_live_site .'/images/stories/'. $currentpage->image;
		$currentpage->align = $currentcat->image_position;
		
	}
	
	$where[] = "c.published = 1";
	$where 	= ( count( $where ) ? "\n WHERE ". implode( "\n AND ", $where ) : '' );
	
	// get the total number of records
	$query = "SELECT COUNT(*)"
	. "\n FROM #__tutorials AS c"
	. "\n LEFT JOIN #__tutorials_cat AS cc ON cc.id = c.catid"
	. "\n LEFT JOIN #__tutorials_sec AS s ON s.id = c.sectionid"
	. $where
	;
	$database->setQuery( $query );
	$total = $database->loadResult();
	
	$limit = $limit ? $limit : $params->get( 'display_num' ) ;
	if ( $total <= $limit ) {
		$limitstart = 0;
	}
	
	require_once( $GLOBALS['mosConfig_absolute_path'] . '/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit );
	
	// get the list of items
	$query = "SELECT c.*, c.date AS created, u.name AS editor, v.username AS author, v.id AS authorid, s.title AS section, cc.title AS category, cc.image AS catimg"
	. "\n FROM #__tutorials AS c"
	. "\n LEFT JOIN #__tutorials_cat AS cc ON cc.id = c.catid"
	. "\n LEFT JOIN #__tutorials_sec AS s ON s.id = c.sectionid"
	. "\n LEFT JOIN #__groups AS g ON g.id = c.access"
	. "\n LEFT JOIN #__users AS u ON u.id = c.checked_out"
	. "\n LEFT JOIN #__users AS v ON v.id = c.created_by"
	. $where
	. "\n ORDER BY c.date DESC"
	;
	$database->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $database->loadObjectList();
	
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	if ( !$sectionid && !$catid ) {
		// Dynamic Page Title
		$mainframe->SetPageTitle( $params->get( 'header' ) );
		// page header
		$currentpage->header = $params->get( 'header' );
		// page description
		$currentpage->descrip = $params->get( 'description_text' );
		// page image
		$currentpage->image = $params->get( 'image' ) != -1;
		$currentpage->img = $mosConfig_live_site .'/images/stories/'. $params->get( 'image' );
		$currentpage->align = $params->get( 'image_align' );
	}

	HTML_tutorials::displaylist( $rows, $sectionid, $catid, $currentpage, $params, $pageNav );
}


function getLink ( $id ) {
	global $database, $my;

	$link = new mosTutorial($database);
	$link->load((int)$id);
	
	/*
	* Check if link is published
	*/
	if (!$link->published) {
		mosNotAuth();
		return;
	}
	
	$cat = new mosTutorials_cat($database);
	$cat->load((int)$link->catid);
	
	/*
	* Check if category is published
	*/
	if (!$cat->published) {
		mosNotAuth();
		return;
	}
	/*
	* check whether category access level allows access
	*/
	if ( $cat->access > $my->gid ) {	
		mosNotAuth();  
		return;
	}

	// Record the hit
	$query = "UPDATE #__tutorials"
	. "\n SET hits = hits + 1"
	. "\n WHERE id = " . (int) $id
	;
	$database->setQuery( $query );
	$database->query();

	if ( $link->url ) {
		// redirects to url if matching id found
		mosRedirect ( $link->url );
	} else {		
		// redirects to tutorial category page if no matching id found
		listTutorials( $sectionid, $catid );
	}
}

function viewTutorial ( $id ) {
	global $database, $my, $mainframe, $Itemid;
	
	// load the row from the db table
	$row = new mosTutorial($database);
	$row->load((int)$id);
	
	// Parameters
	$menu = $mainframe->get( 'menu' );
	$params = new mosParameters( $menu->params );
	$params->def( 'pageclass_sfx', '' );
	$params->def( 'hits', $mainframe->getCfg( 'hits' ) );
	$params->def( 'back_button', $mainframe->getCfg( 'back_button' ) );
	
	// main query
	$query = "SELECT a.*, u.username AS author, u.id AS authorid, u.usertype, cc.title AS category, s.title AS section, g.name AS groups, cc.image AS catimg,"
	. "\n s.published AS sec_pub, cc.published AS cat_pub, s.access AS sec_access, cc.access AS cat_access,"
	. "\n s.id AS sec_id, cc.id as cat_id"
	. "\n FROM #__tutorials AS a"
	. "\n LEFT JOIN #__tutorials_cat AS cc ON cc.id = a.catid"
	. "\n LEFT JOIN #__tutorials_sec AS s ON s.id = cc.section"
	. "\n LEFT JOIN #__users AS u ON u.id = a.created_by"
	. "\n LEFT JOIN #__groups AS g ON g.id = a.access"
	. "\n WHERE a.id = " . (int) $id
	//. "\n AND a.access <= " . (int) $gid
	;
	$database->setQuery( $query );
	$row = NULL;

	if ( $database->loadObject( $row ) ) {
		/*
		* check whether category is published
		*/
		if ( !$row->cat_pub && $row->catid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether section is published
		*/
		if ( !$row->sec_pub && $row->sectionid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether category access level allows access
		*/
		if ( ($row->cat_access > $my->gid) && $row->catid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether section access level allows access
		*/
		if ( ($row->sec_access > $my->gid) && $row->sectionid ) {
			mosNotAuth();
			return;
		}
	}
	
	// Record the hit
	$query = "UPDATE #__tutorials"
	. "\n SET views = views + 1"
	. "\n WHERE id = " . (int) $id
	;
	$database->setQuery( $query );
	$database->query();
	
	// Dynamic Page Title
	$mainframe->SetPageTitle( $row->title );

	HTML_tutorials::viewTutorial( $row, $params );
}

/**  NEED MORE CHANGE
 * Shows the email form for a given content item.
 * @param int The content item id
 */
function emailForm( $uid, $gid ) {
	global $database, $mosConfig_hideEmail;

	if ($mosConfig_hideEmail) {
		echo _NOT_AUTH;
		return;
	}

		// security check to see if link exists in a menu
		$link = 'index.php?option=com_tutorials';
		$query = "SELECT id"
		. "\n FROM #__menu"
		. "\n WHERE link LIKE '%$link%'"
		. "\n AND published = 1"
		;
		$database->setQuery( $query );
		$itemid = $database->loadResult();

	$now 		= _CURRENT_SERVER_TIME;
	$nullDate 	= $database->getNullDate();

	// query to check for state and access levels
	$query = "SELECT a.*, cc.name AS category, s.name AS section, s.published AS sec_pub, cc.published AS cat_pub,"
	. "\n  s.access AS sec_access, cc.access AS cat_access, s.id AS sec_id, cc.id as cat_id"
	. "\n FROM #__tutorials AS a"
	. "\n LEFT JOIN #__tutorials_cat AS cc ON cc.id = a.catid"
	. "\n LEFT JOIN #__tutorials_sec AS s ON s.id = cc.section"
	. "\n WHERE a.id = " . (int) $uid
	. "\n AND a.access <= " . (int) $gid
	. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
	. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
	;
	$database->setQuery( $query );
	$row = NULL;

	if ( $database->loadObject( $row ) ) {
		/*
		* check whether category is published
		*/
		if ( !$row->cat_pub && $row->catid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether section is published
		*/
		if ( !$row->sec_pub && $row->sectionid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether category access level allows access
		*/
		if ( ($row->cat_access > $gid) && $row->catid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether section access level allows access
		*/
		if ( ($row->sec_access > $gid) && $row->sectionid ) {
			mosNotAuth();
			return;
		}

		$query = "SELECT template"
		. "\n FROM #__templates_menu"
		. "\n WHERE client_id = 0"
		. "\n AND menuid = 0"
		;
		$database->setQuery( $query );
		$template = $database->loadResult();

		HTML_tutorials::emailForm( $row->id, $row->title, $template, $itemid );
	} else {
		mosNotAuth();
		return;
	}
}

/**  NEED MORE CHANGE
 * Shows the email form for a given content item.
 * @param int The content item id
 */
function emailSend( $uid, $gid ) {
	global $database, $mainframe;
	global $mosConfig_live_site, $mosConfig_sitename, $mosConfig_hideEmail;

	if ($mosConfig_hideEmail) {
		echo _NOT_AUTH;
		return;
	}

	// simple spoof check security
	josSpoofCheck(1);

	// check for session cookie
	// Session Cookie `name`
	$sessionCookieName 	= mosMainFrame::sessionCookieName();
	// Get Session Cookie `value`
	$sessioncookie 		= mosGetParam( $_COOKIE, $sessionCookieName, null );

	if ( !(strlen($sessioncookie) == 32 || $sessioncookie == '-') ) {
		mosErrorAlert( _NOT_AUTH );
	}

	$itemid 	= intval( mosGetParam( $_POST, 'itemid', 0 ) );
	$now 		= _CURRENT_SERVER_TIME;
	$nullDate 	= $database->getNullDate();

	// query to check for state and access levels
	$query = "SELECT a.*, cc.name AS category, s.name AS section, s.published AS sec_pub, cc.published AS cat_pub,"
	. "\n  s.access AS sec_access, cc.access AS cat_access, s.id AS sec_id, cc.id as cat_id"
	. "\n FROM #__tutorials AS a"
	. "\n LEFT JOIN #__tutorials_cat AS cc ON cc.id = a.catid"
	. "\n LEFT JOIN #__tutorials_sec AS s ON s.id = cc.section"
	. "\n WHERE a.id = " . (int) $uid
	. "\n AND a.access <= " . (int) $gid
	. "\n AND ( a.publish_up = " . $database->Quote( $nullDate ) . " OR a.publish_up <= " . $database->Quote( $now ) . " )"
	. "\n AND ( a.publish_down = " . $database->Quote( $nullDate ) . " OR a.publish_down >= " . $database->Quote( $now ) . " )"
	;
	$database->setQuery( $query );
	$row = NULL;

	if ( $database->loadObject( $row ) ) {
		/*
		* check whether category is published
		*/
		if ( !$row->cat_pub && $row->catid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether section is published
		*/
		if ( !$row->sec_pub && $row->sectionid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether category access level allows access
		*/
		if ( ($row->cat_access > $gid) && $row->catid ) {
			mosNotAuth();
			return;
		}
		/*
		* check whether section access level allows access
		*/
		if ( ($row->sec_access > $gid) && $row->sectionid ) {
			mosNotAuth();
			return;
		}

		$email 				= strval( mosGetParam( $_POST, 'email', '' ) );
		$yourname 			= strval( mosGetParam( $_POST, 'yourname', '' ) );
		$youremail 			= strval( mosGetParam( $_POST, 'youremail', '' ) );
		$subject 			= strval( mosGetParam( $_POST, 'subject', '' ) );
		if (empty( $subject )) {
			$subject 		= _EMAIL_INFO . ' ' . $yourname;
		}

		if ($uid < 1 || !$email || !$youremail || ( JosIsValidEmail( $email ) == false ) || (JosIsValidEmail( $youremail ) == false)) {
			mosErrorAlert( _EMAIL_ERR_NOINFO );
		}

		$query = "SELECT template"
		. "\n FROM #__templates_menu"
		. "\n WHERE client_id = 0"
		. "\n AND menuid = 0"
		;
		$database->setQuery( $query );
		$template = $database->loadResult();
		
		// security check to see if link exists in a menu
		$link = 'index.php?option=com_tutorials';
		$query = "SELECT id"
		. "\n FROM #__menu"
		. "\n WHERE link LIKE '%$link%'"
		. "\n AND published = 1"
		;
		$database->setQuery( $query );
		$itemid = $database->loadResult();

		// determine Itemid for Item
		$_itemid = '&Itemid='. $itemid;

		// link sent in email
		$link = sefRelToAbs( 'index.php?option=com_tutorials&task=view&id='. $uid . $_itemid );

		// message text
		$msg = sprintf( _EMAIL_MSG, html_entity_decode( $mosConfig_sitename, ENT_QUOTES ), $yourname, $youremail, $link );

		// mail function
		$success = mosMail( $youremail, $yourname, $email, $subject, $msg );
		if (!$success) {
			mosErrorAlert( _EMAIL_ERR_NOINFO );
		}

		HTML_tutorials::emailSent( $email, $template );
	} else {
		mosNotAuth();
		return;
	}
}


function recordFav() {
	global $database, $my;
	
	$cid 		= intval( mosGetParam( $_REQUEST, 'cid', 0 ) );
	$created 	= date( 'Y-m-d H:i:s' );
	$userid		= $my->id;
	$currip = ( phpversion() <= '4.2.1' ? @getenv( 'REMOTE_ADDR' ) : $_SERVER['REMOTE_ADDR'] );
		
		$query = "SELECT *"
		. "\n FROM #__tutorials_votes"
		. "\n WHERE tutorialid = $cid"
		. "\n AND type LIKE 'links'"
		. "\n AND userid = '$userid'"
		;
		$database->setQuery( $query );
		$voter = $database->loadResult();
		
		if ( $userid ) {
			if ( !$voter ) {
				$query = "INSERT INTO #__tutorials_votes ( tutorialid, type, userid, value, date, userip )"
					. "\n VALUES ( '$cid', 'links', '$userid', '10', '$created', '$currip' )"
				;
				$database->setQuery( $query );
				$database->query() or die( $database->stderr() );
			} else {
			echo "<script> alert('You already there post your vote.'); window.history.go(-1); </script>\n";
			exit();
			}
		} else {
		mosNotAuth();
		return;
		}
		
			// try to find tutorials component's Itemid
			$query = "SELECT id"
				. "\n FROM #__menu"
				. "\n WHERE type = 'components'"
				. "\n AND published = 1"
				. "\n AND link = 'index.php?option=com_tutorials'"
				;
			$database->setQuery( $query );
			$_Itemid = $database->loadResult();
		
			if ($_Itemid != "") {
				$Itemid = $_Itemid;
			}
		
	$link = sefRelToAbs( 'index.php?option=com_tutorials&amp;task=view&amp;id='. $cid .'&amp;Itemid='. $Itemid );
	
	// user vote result	
	$query = "SELECT count(*)"
	. "\n FROM #__tutorials_votes"
	. "\n WHERE tutorialid = $cid"
	. "\n AND type LIKE 'links'"
	;
	$database->setQuery( $query );
	$favCount = $database->loadResult();
	
	$favResult = "<li class=\"tutorials-fav-star\">\n".
                 "<strong id=\"tutorials-fav-count\">\n".
                 "<a href=\"$link\">$favCount</a>\n".
                 "</strong>\n".
                 "</li>\n".
                 "<li class=\"tutorials-fav-it\">\n".
                 "<span id=\"tutorials-fav-it\">\n".
                 "Votar\n".
                 "</span>\n".
                 "</li>";

	echo $favCountResult = "tutorials-fav-count-$cid|$favResult";
	exit();
}


function saveComment() {
	global $database, $my;
	
	$cid 		= intval( mosGetParam( $_REQUEST, 'tutorialid', 0 ) );
	$userid		= intval( mosGetParam( $_REQUEST, 'userid', 0 ) );
	$created 	= date( 'Y-m-d H:i:s' );
	$parentid	= intval( mosGetParam( $_REQUEST, 'parentid', 0 ) );
	$published	= intval( mosGetParam( $_REQUEST, 'published', 0 ) );
	$currip 	= ( phpversion() <= '4.2.1' ? @getenv( 'REMOTE_ADDR' ) : $_SERVER['REMOTE_ADDR'] );
	$comment	= $_POST["comment"];
	$comment  	= strip_tags($comment);
	$comment  	= mysql_escape_string(strip_tags($comment));
		
		if ( $my->id ) {
				$query = "INSERT INTO #__tutorials_comments ( tutorialid, userid, parentid, comments, date, userip, published )"
					. "\n VALUES ( '$cid', '$userid', '$parentid', '$comment', '$created', '$currip', '$published' )"
				;
				$database->setQuery( $query );
				$database->query() or die( $database->stderr() );
		} else {
		mosNotAuth();
		return;
		}
		
			// try to find tutorials component's Itemid
			$query = "SELECT id"
				. "\n FROM #__menu"
				. "\n WHERE type = 'components'"
				. "\n AND published = 1"
				. "\n AND link = 'index.php?option=com_tutorials'"
				;
			$database->setQuery( $query );
			$_Itemid = $database->loadResult();
		
			if ($_Itemid != "") {
				$Itemid = $_Itemid;
			}
			
	// get comment id
	$query = "SELECT id"
	. "\n FROM #__tutorials_comments"
	. "\n WHERE tutorialid = $cid"
	. "\n AND published = 1"
	. "\n ORDER BY id DESC"
	. "\n LIMIT 1"
	;
	$database->setQuery( $query );
	$comid = $database->loadResult();
			
	mosRedirect( 'index.php?option=com_tutorials&amp;task=view&amp;id='. $cid .'&amp;Itemid='. $Itemid .'#comment'. $comid );
}


function editTutorial( $option, $id ) {
	global $database, $my, $mosConfig_absolute_path, $mosConfig_live_site;
	global $mainframe;
	
	if ($my->gid < 1) {
		mosNotAuth();
		return;
	}
	
	// security check to see if link exists in a menu
	$link = 'index.php?option=com_tutorials';
	$query = "SELECT id"
	. "\n FROM #__menu"
	. "\n WHERE link LIKE '%$link%'"
	. "\n AND published = 1"
	;
	$database->setQuery( $query );
	$exists = $database->loadResult();
	if ( !$exists ) {						
		mosNotAuth();
		return;
	}

	$lists = array();

	$row = new mosTutorial( $database );
	// load the row from the db table
	$row->load( (int)$id );
	
	// page title
	$mainframe->setPageTitle( $id ? 'Editar' : 'Enviar un nuevo tip' );
	
	//get username
	$query = "SELECT a.id, u.username, a.created_by"
	. "\n FROM #__tutorials AS a"
	. "\n LEFT JOIN #__users AS u ON u.id = a.created_by"
	. "\n WHERE a.id = " . (int) $row->id
	;
	$database->setQuery( $query );
	$usered = $database->loadObjectList();

	if ($id) {
		$row->checkout( $my->id );
			foreach($usered as $user) {
				$row->creator	 = $user->username;
				$row->created	 = $user->created_by;
			}
		$row->imageurl = $mosConfig_live_site .'/components/com_tutorials/images/'. $row->imageurl;
		$lists['image'] = '<img src="' .$row->imageurl. '" align="left" hspace="5" alt="Image" />';
	} else {
		// initialise new record
		$row->published  = 1;
		$row->ordering 	 = 0;
		$row->creator	 = $my->username;
		$row->created	 = $my->id;
		$imgpreviewjs	 = "previewImage(this);";
		$lists['image'] = '<input class="inputbox" type="file" name="image" id="tutimage" size="60" onchange="'. $imgpreviewjs .'" /><br />
						   <div class="smallgrey">Allow file extension (.gif, .jpg, .jpeg) || no larger than 5k || dimensions must be 40 x 40 pixels.</div>';
	}
	
	// build list of sections
	$sectionid = $row->sectionid;
	
	$javascript = "onchange=\"changeDynaList( 'catid', sectioncategories, document.adminForm.sectionid.options[document.adminForm.sectionid.selectedIndex].value, 0, 0);\"";
	$query = "SELECT s.id, s.title"
	. "\n FROM #__tutorials_sec AS s"
	. "\n ORDER BY s.ordering";
	$database->setQuery( $query );
	
	if ( $sectionid == 0 ) {
		$sections[] = mosHTML::makeOption( '-1', 'Select Section', 'id', 'title' );
		$sections = array_merge( $sections, $database->loadObjectList() );
		$lists['sectionid'] = mosHTML::selectList( $sections, 'sectionid', 'class="inputbox" size="1" '. $javascript, 'id', 'title' );
	} else {
		$sections = $database->loadObjectList();
		$lists['sectionid'] = mosHTML::selectList( $sections, 'sectionid', 'class="inputbox" size="1" '. $javascript, 'id', 'title', intval( $row->sectionid ) );
	}
	
	// build list of category
	foreach($sections as $section) {
		$section_list[] = $section->id;
		// get the type name - which is a special category
		if ($row->sectionid){
			if ( $section->id == $row->sectionid ) {
			}
		} else {
			if ( $section->id == $sectionid ) {		
			}
		}
	}
	
	$sectioncategories 			= array();
	$sectioncategories[-1] 		= array();
	$sectioncategories[-1][] 	= mosHTML::makeOption( '-1', 'Select Category', 'id', 'title' );
	mosArrayToInts( $section_list );
	$section_list 				= 'section=' . implode( ' OR section=', $section_list );

	$query = "SELECT id, title, section"
	. "\n FROM #__tutorials_cat"
	. "\n WHERE ( $section_list )"
	. "\n ORDER BY ordering"
	;
	$database->setQuery( $query );
	$cat_list = $database->loadObjectList();
	foreach($sections as $section) {
		$sectioncategories[$section->id] = array();
		$rows2 = array();
		foreach($cat_list as $cat) {
			if ($cat->section == $section->id) {
				$rows2[] = $cat;
			}
		}
		foreach($rows2 as $row2) {
			$sectioncategories[$section->id][] = mosHTML::makeOption( $row2->id, $row2->title, 'id', 'title' );
		}
	}

 	// get list of categories
  	if ( !$row->catid && !$row->sectionid ) {
 		$categories[] 		= mosHTML::makeOption( '-1', 'Select Category', 'id', 'title' );
 		$lists['catid'] 	= mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1"', 'id', 'title' );
  	} else {
		$categoriesA = array();
		if ( $sectionid == 0 ) {
			foreach($cat_list as $cat) {
				$categoriesA[] = $cat;
			}
		} else {
			foreach($cat_list as $cat) {
				if ($cat->section == $sectionid) {
					$categoriesA[] = $cat;
				}
			}
		}
		$categories[] 		= mosHTML::makeOption( '-1', 'Select Category', 'id', 'title' );
		$categories 		= array_merge( $categories, $categoriesA );
 		$lists['catid'] 	= mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1"', 'id', 'title', intval( $row->catid ) );
  	}//end categories

	HTML_tutorials::editTutorial( $row, $option, $lists, $sectioncategories );
}

/**
* Saves the record on an edit form submit
* @param database A database connector object
*/
function saveTutorial( $option ) {
	global $database, $my, $mosConfig_absolute_path;

	if ($my->gid < 1) {
		mosNotAuth();
		return;
	}		
	
	// simple spoof check security
	josSpoofCheck();
	
	/**
	* get image upload function
	*/
	//make sure this directory is writable!
	$path_image = $mosConfig_absolute_path.'/components/com_tutorials/images/';
	//define file size limit
	$limit_size = 5000;//K
	//define file width/height size
	$max_width = 40; 
	$max_height = 40;
	//Limit allowed extensions? (no for all extensions allowed)
	$extlimit = "yes";
	//List of allowed extensions if extlimit = yes
	$allow_image = array(".gif",".jpg",".jpeg"); 
	//the image -> variables
	$file_type  = $_FILES['image']['type'];
    $file_name  = $_FILES['image']['name'];
    $file_size  = $_FILES['image']['size'];
    $file_tmp   = $_FILES['image']['tmp_name'];		
	
	if ( $file_tmp ) {
		list($width, $height) = getimagesize( $file_tmp );
			
		//check if you have selected a file.
		/*if(!is_uploaded_file($file_tmp)){
			echo "<script> alert('Please select a file to upload!.'); window.history.go(-1); </script>\n";
			exit();
		}*/
		//check the file's extension
		$ext = strrchr($file_name,'.');
		$ext = strtolower($ext);
		//uh-oh! the file extension is not allowed!
		if ( ( $extlimit == "yes" ) && (!in_array( $ext, $allow_image )) ) {
			echo "<script> alert('Wrong file extension.'); window.history.go(-1); </script>\n";
			exit();
		}
			
		//check the file's dimension
		if( $width > $max_width && $height > $max_height ) {
			echo "<script> alert('Exceeded image dimension limits.'); window.history.go(-1); </script>\n";
			exit();
		}
			
		//check the file's limit
		if( $file_size >= $limit_size ){
			echo "<script> alert('File size is greater than the file size limit.'); window.history.go(-1); </script>\n";
			exit();
		}
	}
		
	$row = new mosTutorial( $database );
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	
	if ($row->id) {
		
	} else {
	$row->date = date( 'Y-m-d H:i:s' );
	}
		
	if (!$row->check()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	
	// image upload save
	if ( $file_tmp ) {
		//get username
		$query = "SELECT a.id, u.username"
		. "\n FROM #__tutorials AS a"
		. "\n LEFT JOIN #__users AS u ON u.id = a.created_by"
		. "\n WHERE a.id = " . (int) $row->id
		;
		$database->setQuery( $query );
		$usered = $database->loadObjectList();
		
			foreach($usered as $user) {
				$username	 = $user->username;
			}
			
		//so, whats the file's extension?
		$getExt = explode ('.', $file_name);
		$file_ext = $getExt[count($getExt)-1];
		//create a file name
		//$basename = preg_replace('/[^a-z0-9_\-\.]/i', '_', $row->title);// clean odd characters (including spaces)
		$basename = $row->id;
		$image_name   = strtolower( $basename .'_by_'. $username );
		//$image_name = substr(($image_mn), 0, 15);
		//move_uploaded_file ($file_tmp, "$path_image/$image_name.$file_ext");
	
		if ( move_uploaded_file( $file_tmp, "$path_image/$image_name.$file_ext" ) ) {
			  $query = "UPDATE #__tutorials"
			  . "\n SET imageurl = ('$image_name.$file_ext')"
			  . "\n WHERE id = " . (int) $row->id;
			  $database->setQuery($query);
			  $database->query();
			  echo $database->getErrorMsg(); 
		}
	}
	
	
	$row->checkin();
	$row->updateOrder();
	
	// try to find tutorials component's Itemid
	$query = "SELECT id"
	. "\n FROM #__menu"
	. "\n WHERE type = 'components'"
	. "\n AND published = 1"
	. "\n AND link = 'index.php?option=com_tutorials'"
	;
	$database->setQuery( $query );
	$_Itemid = $database->loadResult();
		
	if ($_Itemid != "") {
		$Itemid = $_Itemid;
	}

	mosRedirect( 'index.php?option=com_tutorials&amp;Itemid='.$Itemid, 'Exito! Su tip ha sido enviado.' ); 
}

function cancelTutorial( $option ) {
	global $database, $my;

	if ($my->gid < 1) {
		mosNotAuth();
		return;
	}

	$row = new mosTutorial( $database );
	$row->id = intval( mosGetParam( $_POST, 'id', 0 ) );
	$row->checkin();

	$referer = strval( mosGetParam( $_POST, 'referer', '' ) );
	mosRedirect( $referer );
}

?>
